//+------------------------------------------------------------------+
//|                                      #MTF Stochastic Thread.mq4  |
//|     Based on Spudfyre's Thread theory                            |
//|     Display Stochastics Elasticity                               |
//|                                                                  |
//|                                                                  |
//|     v 1.2: bug fix, and hability to set 2 different colours      |
//|                                                                  |
//|                                                            emda  |
//+------------------------------------------------------------------+

#property copyright "Copyright  2007, Emda"
#property link "http://www.forexfactory.com/showthread.php?t=37111"
//----
#property indicator_separate_window
#property indicator_minimum -20
#property indicator_maximum 100
#property indicator_buffers 2
#property indicator_color1 LightSteelBlue
#property indicator_color2 LightSalmon
#property indicator_width1 5
#property indicator_width2 5

string version="1.2";

//---- input parameters
extern string coment1 = "--- stoch wall params ------";
extern int Periodwall = 14;
extern int Slowing = 3;
extern bool AutoTf = true;
extern int AutoTfMin = 6;
extern int AutoTfMax = 24;
extern string coment2 = "--- manual LTFS params ------";
extern int Periodl3 = 5;
extern int Periodl2 = 9;
extern int Periodl1 = 11;
extern int Slowingl1 = 3;
extern int Slowingl2 = 3;
extern int Slowingl3 = 3;
extern string coment3 = "--- manual HTFS params ------";
extern int Periodu1 = 17;
extern int Periodu2 = 20;
extern int Periodu3 = 24;
extern int Slowingu1 = 3;
extern int Slowingu2 = 3;
extern int Slowingu3 = 3;
extern string coment4 = "--- Elasticity params ------";
extern double MinimumElasticity = 10;
extern double ScaleMax = 20;

//---- buffers
double BufferElast1[];
double BufferElast2[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   IndicatorBuffers(2);
//---- indicator lines
   SetIndexStyle(0, DRAW_HISTOGRAM);
   SetIndexBuffer(0, BufferElast1);
   SetIndexStyle(1, DRAW_HISTOGRAM);
   SetIndexBuffer(1, BufferElast2);
   
//---- name for DataWindow and indicator subwindow label
   string short_name;
   short_name="MultiPeriod Stochastics Elasticity v" + version;
   IndicatorShortName(short_name);
   SetIndexLabel(0, "MPS elasticity " + Periodwall);
   return(0);
}

int deinit()
{
   return(0);
}


int start()
  {

int counted_bars=IndicatorCounted();
//---- check for possible errors
if (counted_bars<0) return(-1);
//---- last counted bar will be recounted
if (counted_bars>0) counted_bars--;
int pos=Bars-counted_bars;


//---- main calculation loop
while(pos>=0)
{
    if (AutoTf){
      int lrange = Periodwall - AutoTfMin;
      int hrange = AutoTfMax - Periodwall;
      Periodl1 = Periodwall - (lrange / 3);
      Periodl2 = Periodwall - ((lrange * 2) / 3);
      Periodl3 = Periodwall - lrange;
      Periodu1 = Periodwall + (hrange / 3);
      Periodu2 = Periodwall + ((hrange * 2) / 3);
      Periodu3 = Periodwall + hrange;
    }
    if (Periodl1<0) Periodl1=Periodwall;
    if (Periodl2<0) Periodl2=Periodwall;
    if (Periodl3<0) Periodl3=Periodwall;
    
      
      double swall = iStochastic(NULL,0,Periodwall,3,Slowing,0,0,0,pos);
      double sl1 = iStochastic(NULL,0,Periodl1,3,Slowingl1,0,0,0,pos);
      double sl2 = iStochastic(NULL,0,Periodl2,3,Slowingl2,0,0,0,pos);
      double sl3 = iStochastic(NULL,0,Periodl3,3,Slowingl3,0,0,0,pos);

      double su1 = iStochastic(NULL,0,Periodu1,3,Slowingu1,0,0,0,pos);
      double su2 = iStochastic(NULL,0,Periodu2,3,Slowingu2,0,0,0,pos);
      double su3 = iStochastic(NULL,0,Periodu3,3,Slowingu3,0,0,0,pos);

      
      double lmatrix[3];
      double umatrix[3];
      umatrix[0]=su3;
      umatrix[1]=su2;
      umatrix[2]=su1;
      lmatrix[0]=sl1;
      lmatrix[1]=sl2;
      lmatrix[2]=sl3;
      
      double umaxstoch = umatrix[ArrayMaximum(umatrix)];
      double uminstoch = umatrix[ArrayMinimum(umatrix)];
      
      double lmaxstoch = lmatrix[ArrayMaximum(lmatrix)];
      double lminstoch = lmatrix[ArrayMinimum(lmatrix)];
      
      double ldeployment = lmaxstoch-lminstoch;
      double udeployment = umaxstoch-uminstoch;
      double ratioelast;
      
      //if (udeployment>ldeployment) ratioelast = udeployment-ldeployment;
      ratioelast = ldeployment-udeployment;
      
      
      //if (elast<0) elast=0;
      
       double elast;
       if (ratioelast<0){
         elast = ratioelast+MinimumElasticity;
         if (elast<0) BufferElast1[pos]=0-elast; else BufferElast1[pos]=0;
       } else {
         elast = ratioelast-MinimumElasticity;
         if (elast>0) BufferElast2[pos]=elast; else BufferElast2[pos]=0;
       }
       
      pos--;
}

 
//----
   return(0);
   
   
  }
//+------------------------------------------------------------------+