//+------------------------------------------------------------------+
//|                                      #MTF Stochastic Thread.mq4  |
//|     Based on Spudfyre's Thread theory                            |
//|     Display Stochastics rainbow based on different periods.      |
//|                                                                  |
//|                                                            emda  |
//+------------------------------------------------------------------+

#property copyright "Copyright  2007, Spudfyre & Emda"
#property link "http://www.forexfactory.com/showthread.php?t=37111"
//----
#property indicator_separate_window
#property indicator_minimum -20
#property indicator_maximum 100
#property indicator_buffers 8
#property indicator_color1 LimeGreen
#property indicator_width1 2
#property indicator_color2 Blue
#property indicator_color3 Blue
#property indicator_color4 Blue
#property indicator_color5 Red
#property indicator_color6 Red
#property indicator_color7 Red
#property indicator_color8 DarkGray
#property indicator_width8 3
#property indicator_level1 23.6
#property indicator_level2 76.4
#property indicator_level3 50
#property indicator_level4 0
#property indicator_levelcolor Gray



string version="1.0";

//---- input parameters
extern string coment1 = "--- stoch wall params ------";
extern int Periodwall = 14;
extern int Slowing = 3;
extern bool AutoTf = true;
extern int AutoTfMin = 6;
extern int AutoTfMax = 24;
extern string coment2 = "--- manual LTFS params ------";
extern int Periodl3 = 5;
extern int Periodl2 = 9;
extern int Periodl1 = 11;
extern int Slowingl1 = 3;
extern int Slowingl2 = 3;
extern int Slowingl3 = 3;
extern string coment3 = "--- manual HTFS params ------";
extern int Periodu1 = 17;
extern int Periodu2 = 20;
extern int Periodu3 = 24;
extern int Slowingu1 = 3;
extern int Slowingu2 = 3;
extern int Slowingu3 = 3;
extern string coment4 = "--- Deployment params ------";
extern double DeploymentSignal = 3;
extern double DeploymentScaleMax = 20;

//---- buffers
double Bufferwall[];
double Bufferl1[];
double Bufferl2[];
double Bufferl3[];
double Bufferu1[];
double Bufferu2[];
double Bufferu3[];
double BufferDeployment[];


//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   IndicatorBuffers(8);
//---- indicator lines
   SetIndexStyle(0, DRAW_LINE);
   SetIndexBuffer(0, Bufferwall);
   SetIndexStyle(1, DRAW_LINE);
   SetIndexBuffer(1, Bufferl3);
   SetIndexStyle(2, DRAW_LINE);
   SetIndexBuffer(2, Bufferl2);
   SetIndexStyle(3, DRAW_LINE);
   SetIndexBuffer(3, Bufferl1);
   SetIndexStyle(4, DRAW_LINE);
   SetIndexBuffer(4, Bufferu1);
   SetIndexStyle(5, DRAW_LINE);
   SetIndexBuffer(5, Bufferu2);
   SetIndexStyle(6, DRAW_LINE);
   SetIndexBuffer(6, Bufferu3);
   SetIndexStyle(7, DRAW_HISTOGRAM);
   SetIndexBuffer(7, BufferDeployment);
   
//---- name for DataWindow and indicator subwindow label
   string short_name;
   short_name="MultiPeriod Stochastics Rainbow " + version;
   IndicatorShortName(short_name);
   SetIndexLabel(0, "MPS wall" + Periodwall);

   return(0);
}

int deinit()
{
   return(0);
}


int start()
  {

int counted_bars=IndicatorCounted();
//---- check for possible errors
if (counted_bars<0) return(-1);
//---- last counted bar will be recounted
if (counted_bars>0) counted_bars--;
int pos=Bars-counted_bars;


//---- main calculation loop
while(pos>=0)
{
    if (AutoTf){
      int lrange = Periodwall - AutoTfMin;
      int hrange = AutoTfMax - Periodwall;
      Periodl1 = Periodwall - (lrange / 3);
      Periodl2 = Periodwall - ((lrange * 2) / 3);
      Periodl3 = Periodwall - lrange;
      Periodu1 = Periodwall + (hrange / 3);
      Periodu2 = Periodwall + ((hrange * 2) / 3);
      Periodu3 = Periodwall + hrange;
    }
    if (Periodl1<0) Periodl1=Periodwall;
    if (Periodl2<0) Periodl2=Periodwall;
    if (Periodl3<0) Periodl3=Periodwall;
    
      
      double swall = iStochastic(NULL,0,Periodwall,3,Slowing,0,0,0,pos);
      Bufferwall[pos]= swall;

      double sl1 = iStochastic(NULL,0,Periodl1,3,Slowingl1,0,0,0,pos);
      Bufferl1[pos]= sl1;
      double sl2 = iStochastic(NULL,0,Periodl2,3,Slowingl2,0,0,0,pos);
      Bufferl2[pos]= sl2;
      double sl3 = iStochastic(NULL,0,Periodl3,3,Slowingl3,0,0,0,pos);
      Bufferl3[pos]= sl3;      

      double su1 = iStochastic(NULL,0,Periodu1,3,Slowingu1,0,0,0,pos);
      Bufferu1[pos]= su1;
      double su2 = iStochastic(NULL,0,Periodu2,3,Slowingu2,0,0,0,pos);
      Bufferu2[pos]= su2;
      double su3 = iStochastic(NULL,0,Periodu3,3,Slowingu3,0,0,0,pos);
      Bufferu3[pos]= su3;      
      
      double smatrix[7];
      smatrix[0]=su3;
      smatrix[1]=su2;
      smatrix[2]=su1;
      smatrix[3]=swall;
      smatrix[4]=sl1;
      smatrix[5]=sl2;
      smatrix[6]=sl3;
      double maxstoch = smatrix[ArrayMaximum(smatrix)];
      double minstoch = smatrix[ArrayMinimum(smatrix)];
      
      double deployment = (0 - (((maxstoch-minstoch)*DeploymentScaleMax)/60)) + DeploymentSignal;
      if (deployment <0) BufferDeployment[pos]= deployment; else BufferDeployment[pos]=0;      
      
      pos--;
}

 
//----
   return(0);
   
   
  }
//+------------------------------------------------------------------+